#property copyright "Copyright  2011"
#property link      "forex-tools.tk"
//---- indicator settings
#property indicator_chart_window
//---- input parameters
#define _Label "Label_v132_"
#define _LenLabel 11
//---- indicator parameters
extern datetime _DateStart =D'24.03.2011 00:00:00'; // ,     
extern bool     _IsDateCur =false; //  ,       
extern double   _Angle     =2.0; //  
//
extern color  _color1 =Yellow; //   ==    
extern int    _style1 =0;      //   (0,1,2,3,4)
extern int    _width1 =2;      //  
//
extern color  _color2 =Blue;   //   ==    
extern int    _style2 =0;      //   (0,1,2,3,4)
extern int    _width2 =2;      //  
//
extern color  _color3 =Red;    //   ==    
extern int    _style3 =0;      //   (0,1,2,3,4)
extern int    _width3 =2;      //  
//
extern color  _color4 =Yellow; //   ==   
extern int    _style4 =1;      //   (0,1,2,3,4)
extern int    _width4 =0;      //  
//
extern color  _color5 =Blue;   //   ==    
extern int    _style5 =1;      //   (0,1,2,3,4)
extern int    _width5 =0;      //  
//
extern color  _color6 =Red;    //   ==    
extern int    _style6 =1;      //   (0,1,2,3,4)
extern int    _width6 =0;      //  
//
extern color  _color7 =Yellow; //   ==   
extern int    _style7 =0;      //   (0,1,2,3,4)
extern int    _width7 =0;      //  
//


//=++==============================================================++=
int init()
{
   if(_IsDateCur) _DateStart = TimeCurrent();
   //
   CreateGraficAlert();
   return(0);
}


//=++==============================================================++=
int start()
{
   int i;
   double price1,price2;
   //
   int shiftW;
   int shiftD;
   datetime dateW,dateW_End;
   datetime dateD,dateD_End;
   double priceW;
   double priceD;
   //
   int shiftW1, shiftW1max,shiftW1min;
   datetime dateW1,dateW1max,dateW1min;
   double priceW1,priceW1max,priceW1min;
   //
   int shiftD1, shiftD1max,shiftD1min;
   datetime dateD1,dateD1max,dateD1min;
   double priceD1,priceD1max,priceD1min;
   //
   int shiftD2;
   datetime dateD2;
   double priceD2;
   //==========
   shiftW=iBarShift(Symbol(),PERIOD_W1,_DateStart,false);
   dateW=iTime(Symbol(),PERIOD_W1,shiftW);
   dateW_End=dateW+PERIOD_D1*6*60;
   //
   shiftD=iBarShift(Symbol(),PERIOD_D1,_DateStart,false);
   dateD=iTime(Symbol(),PERIOD_D1,shiftD);
   dateD_End=dateD+PERIOD_D1*60;
   //==========
   shiftW=iBarShift(Symbol(),Period(),dateW_End,false)+1;
   while(iTime(Symbol(),Period(),shiftW)>dateW)
      shiftW++;
   dateW=iTime(Symbol(),Period(),shiftW);
   priceW=iClose(Symbol(),Period(),shiftW);
   //
      //SetGraficAlert_GANNLINE(_Label+"11",dateW,priceW,dateW_End,_Angle);
      //SetGraficAlert_GANNLINE(_Label+"12",dateW,priceW,dateW_End,-1*_Angle);
   //==========
   shiftW1=iBarShift(Symbol(),PERIOD_W1,dateW,false);
   dateW1=iTime(Symbol(),PERIOD_W1,shiftW1);
   //
   shiftW1=shiftW;
   shiftW1max=shiftW1; priceW1max=iHigh(Symbol(),Period(),shiftW1max);
   shiftW1min=shiftW1; priceW1min=iLow(Symbol(),Period(),shiftW1min);
   //
   while(iTime(Symbol(),Period(),shiftW1)>dateW1)
   {
      price1=iHigh(Symbol(),Period(),shiftW1);
      if(price1>priceW1max)
      {
         priceW1max=price1;
         shiftW1max=shiftW1;
      }
      price2=iLow(Symbol(),Period(),shiftW1);
      if(price2<priceW1min)
      {
         priceW1min=price2;
         shiftW1min=shiftW1;
      }
      shiftW1++;
   }
      //
      dateW1=iTime(Symbol(),Period(),shiftW1);
      priceW1=iClose(Symbol(),Period(),shiftW1);
      //
      SetGraficAlert_GANNLINE(_Label+"11",dateW1,priceW1,dateW_End,_Angle);
      SetGraficAlert_GANNLINE(_Label+"12",dateW1,priceW1,dateW_End,-1*_Angle);
   //
   dateW1max=iTime(Symbol(),Period(),shiftW1max);
   dateW1min=iTime(Symbol(),Period(),shiftW1min);
   //
   SetGraficAlert_GANNLINE(_Label+"21",dateW1max,priceW1max,dateW_End,_Angle);
   SetGraficAlert_GANNLINE(_Label+"22",dateW1max,priceW1max,dateW_End,-1*_Angle);
   //
   SetGraficAlert_GANNLINE(_Label+"31",dateW1min,priceW1min,dateW_End,_Angle);
   SetGraficAlert_GANNLINE(_Label+"32",dateW1min,priceW1min,dateW_End,-1*_Angle);
   //==========
   shiftD=iBarShift(Symbol(),Period(),dateD_End,false)+1;
   while(iTime(Symbol(),Period(),shiftD)>dateD)
      shiftD++;
   shiftD++;
   dateD=iTime(Symbol(),Period(),shiftD);
   priceD=iClose(Symbol(),Period(),shiftD);
   //
   SetGraficAlert_GANNLINE(_Label+"41",dateD,priceD,dateD_End,_Angle);
   SetGraficAlert_GANNLINE(_Label+"42",dateD,priceD,dateD_End,-1*_Angle);
   //==========
   shiftD1=iBarShift(Symbol(),PERIOD_D1,dateD,false);
   dateD1=iTime(Symbol(),PERIOD_D1,shiftD1);
   //
   shiftD1=shiftD;
   shiftD1max=shiftD1; priceD1max=iHigh(Symbol(),Period(),shiftD1max);
   shiftD1min=shiftD1; priceD1min=iLow(Symbol(),Period(),shiftD1min);
   //
   while(iTime(Symbol(),Period(),shiftD1)>dateD1)
   {
      price1=iHigh(Symbol(),Period(),shiftD1);
      if(price1>priceD1max)
      {
         priceD1max=price1;
         shiftD1max=shiftD1;
      }
      price2=iLow(Symbol(),Period(),shiftD1);
      if(price2<priceD1min)
      {
         priceD1min=price2;
         shiftD1min=shiftD1;
      }
      shiftD1++;
   }
   //
   dateD1max=iTime(Symbol(),Period(),shiftD1max);
   dateD1min=iTime(Symbol(),Period(),shiftD1min);
   //
   SetGraficAlert_GANNLINE(_Label+"51",dateD1max,priceD1max,dateD_End,_Angle);
   SetGraficAlert_GANNLINE(_Label+"52",dateD1max,priceD1max,dateD_End,-1*_Angle);
   //
   SetGraficAlert_GANNLINE(_Label+"61",dateD1min,priceD1min,dateD_End,_Angle);
   SetGraficAlert_GANNLINE(_Label+"62",dateD1min,priceD1min,dateD_End,-1*_Angle);
   //==========
   shiftD2=iBarShift(Symbol(),PERIOD_D1,dateD1,false);
   dateD2=iTime(Symbol(),PERIOD_D1,shiftD2);
   //
   shiftD2=iBarShift(Symbol(),Period(),dateD_End,false)+1;
   while(iTime(Symbol(),Period(),shiftD2)>dateD2)
      shiftD2++;
   shiftD2++;
   dateD2=iTime(Symbol(),Period(),shiftD2);
   priceD2=iClose(Symbol(),Period(),shiftD2);
   //
   SetGraficAlert_GANNLINE(_Label+"71",dateD2,priceD2,dateD_End,_Angle);
   SetGraficAlert_GANNLINE(_Label+"72",dateD2,priceD2,dateD_End,-1*_Angle);
   //==========
   return(0);
}


//=++==============================================================++=
int deinit()
{
   DeleteGraficAlert();
   return(0);
}


//=++==============================================================++=
void DeleteGraficAlert()
{
   for(int i=ObjectsTotal()-1; i>=0; i--)
   {
       string label=ObjectName(i);
       if(StringSubstr(label,0,_LenLabel)!=_Label)
           continue;
       ObjectDelete(label);   
   }
}


//=++==============================================================++=
void CreateGraficAlert()
{
   CreateGraficAlert_GANNLINE(_Label+"11",_color1,_style1,_width1);
   CreateGraficAlert_GANNLINE(_Label+"12",_color1,_style1,_width1);
   //
   CreateGraficAlert_GANNLINE(_Label+"21",_color2,_style2,_width2);
   CreateGraficAlert_GANNLINE(_Label+"22",_color2,_style2,_width2);
   //
   CreateGraficAlert_GANNLINE(_Label+"31",_color3,_style3,_width3);
   CreateGraficAlert_GANNLINE(_Label+"32",_color3,_style3,_width3);
   //
   CreateGraficAlert_GANNLINE(_Label+"41",_color4,_style4,_width4);
   CreateGraficAlert_GANNLINE(_Label+"42",_color4,_style4,_width4);
   //
   CreateGraficAlert_GANNLINE(_Label+"51",_color5,_style5,_width5);
   CreateGraficAlert_GANNLINE(_Label+"52",_color5,_style5,_width5);
   //
   CreateGraficAlert_GANNLINE(_Label+"61",_color6,_style6,_width6);
   CreateGraficAlert_GANNLINE(_Label+"62",_color6,_style6,_width6);
   //
   CreateGraficAlert_GANNLINE(_Label+"71",_color7,_style7,_width7);
   CreateGraficAlert_GANNLINE(_Label+"72",_color7,_style7,_width7);
}


//=++==============================================================++=
void CreateGraficAlert_GANNLINE(string llabel, color lcolor, int lstyle, int lwidth)
{
   ObjectCreate(llabel,OBJ_GANNLINE,0, 0,0,0,0);
   ObjectSet(llabel,OBJPROP_COLOR,lcolor);
   ObjectSet(llabel,OBJPROP_STYLE,lstyle);
   ObjectSet(llabel,OBJPROP_WIDTH,lwidth);
}


//=++==============================================================++=
void SetGraficAlert_GANNLINE(string llabel, datetime date1, double price1, datetime date2, double scale)
{
   ObjectSet(llabel,OBJPROP_TIME1,date1);
   ObjectSet(llabel,OBJPROP_PRICE1,price1);
   ObjectSet(llabel,OBJPROP_TIME2,date2);
   ObjectSet(llabel,OBJPROP_SCALE,scale);
}

